**
* TEST   Add/Remove stock from customer
**
PROCEDURE TEST

* A example of the use of TranEdit from Bill Kerr 100014,3641
* TranEdit could do with some changes in areas such as scrolling across
* a screen wider than 80 column.  If you do maybe you can let in in on
* the details.
* F11 Deletes a line
* F12 Inserts a Line
* Enjoy!!

SET TALK OFF
SET BORDER TO        DOUBLE
USE equip_0 IN 1 ORDER 1 ALIAS equipment	&& A couple of file to illustrate
USE loctn_0 IN 2 ORDER 1 ALIAS location

DIMENSION CtrlArr[10,4]		&& Need this to be available to TranEdit

DEFINE WINDOW browse FROM 13,3 TO 22,75 COLOR SCHEME 10 SHADOW ;
	 SYSTEM TITLE 'Browse Codes - F5/RightMouse to edit, ESC to exit'
DEFINE WINDOW standby  FROM 17,02 TO 21,77 DOUBLE FLOAT SHADOW COLOR SCHEME 7
DEFINE WINDOW pmmsg FROM 17,6 TO 19,72 COLOR SCHEME 5 SHADOW

ON KEY LABEL F3 DO pop_lst

DIMENSION gaExample[1,4]	&& We have four data fields accross the screen 

gaExample[1,1]=SPACE(6)		&& Pad with field widths
gaExample[1,2]=SPACE(30)
gaExample[1,3]=0
gaExample[1,4]=SPACE(4)

DO setstk						&& Set up controlling options

new=TranEdit(@gaExample, @CtrlArr, 10, 4, .f., 9, "Stock Used/Removed Entry Lines")

	IF new		&& Is true if we did something and we saved it
		=pmt_msg('Creating Stock Used/Removed Entries')
		maxrec=ALEN(gaExample,1)
		FOR i=1 TO maxrec
		   eqp=gaExample[i,1]
		   qty=gaExample[i,3]
		   loc=gaExample[i,4]
		   && Do something useful here
		   =pmt_msg('Creating Stock Used/Removed Entries- ' + STR(i))
		ENDFOR
		=pmt_clr()
	ENDIF

	CLOSE DATABASE
	RELEASE ALL	
	SET TALK ON
	RETURN
**
* SETSTK   Set up order entry controlling fields
**
PROCEDURE setstk
DIMENSION CtrlArr[10,4]	&& Redefine to actual size required

* Column Headings
CtrlArr[1,1]="Code"
CtrlArr[1,2]="Description"
CtrlArr[1,3]="Qty"
CtrlArr[1,4]="Sub Loc"


* Data Picture/Edit clauses
CtrlArr[2,1]="!!!!!!"
CtrlArr[2,2]="XXXXXXXXXXXXXXXXXXXXXXXXXXX"
CtrlArr[2,3]="@Z 999999"
CtrlArr[2,4]="!!!!"

* Prompt Messages
CtrlArr[3,1] ="Enter the equipment code - F3 for List"
CtrlArr[3,2] =""
CtrlArr[3,3] ="Installed quantity -  negative if removing"
CtrlArr[3,4] ="Sub-location if known - F3 for List"

* When clauses
CtrlArr[4,1]=".T."
CtrlArr[4,2]=".F."
CtrlArr[4,3]=".T."
CtrlArr[4,4]=".T."

* Default clauses
CtrlArr[5,1]=""
CtrlArr[5,2]=""
CtrlArr[5,3]="1"
CtrlArr[5,4]=""

* Valid Clauses
CtrlArr[6,1]="PROD_OK()"
CtrlArr[6,2]=".T."
CtrlArr[6,3]=".T."
CtrlArr[6,4]="LOC_OK()"

* Misc Clauses
CtrlArr[7,1]=".T."				&& Pre_delete Row Clause, execute before F11
CtrlArr[8,1]=".T."				&& Post Delete row Clause, execute after F11
CtrlArr[9,1]=".T."				&& Pre-Insert Clause, execute before F12
CtrlArr[10,1]=".T."				&& Post Insert Clause, execute after F12
RETURN
**
* PROD_OK   Check to see if equipment code entered is ok
**
PROCEDURE prod_ok
IF !SEEK(cell,'equipment')  && cell -  holds current field data
   DO standby WITH "The equipment code you have entered does not exist - Press F3 for list"
   RETURN .F.
ENDIF	
laArr[arr_row,2]=equipment->descript && stuff the equipment descr into array
=Arr_disp[2]	&& and then display the contents to the user
RETURN .T.	

**
* LOC_OK   Check to see if sub location code entered is ok
**
PROCEDURE loc_ok
IF EMPTY(cell)			&& Null location is ok
   RETURN .T.
ENDIF
IF !SEEK(cell,'location')
   DO standby WITH "The location code you have entered does not exist - Press F3 for list"
   RETURN .F.
ENDIF	
RETURN .T.	

**
* POP_LST   Pop up Browse box for valid codes
**
PROCEDURE pop_lst
ON KEY LABEL F3
ON KEY LABEL F5 KEYBOARD CHR(23)		&& Control-W to exit browse
	
    DO CASE
      CASE lncol=1
	    SELECT equipment
	    GO TOP
        BROWSE FIELDS code, descript /H='  Description';
          WINDOW browse NOEDIT NOAPPEND NOMENU NODELETE ;
          TITLE 'Equipment Codes - F5/Rightmouse to Select or ESC to exit' ;
          TIMEOUT 60 FREEZE code

	    IF LASTKEY() = 23						&& Control-W
		  laArr[arr_row,2]=equipment->descript  && Save desc in array
		  =Arr_disp[2]							&& And display
	  	  Cell = equipment->code				&& Save selected equipment code
		  laArr[arr_row,1]=equipment->code		&& And into array
		  =Arr_disp[1]							&& Display code
		  IF RDLEVEL()=0						&& Simulate the user
			 KEYBOARD CHR(13)+CHR(13)
		  ELSE
			 CLEAR READ
		  ENDIF
	    ENDIF

      CASE lncol=4
	    SELECT location
	    GO TOP
        BROWSE FIELDS code, descript /H='  Description';
          WINDOW browse NOEDIT NOAPPEND NOMENU NODELETE ;
          TITLE 'Sub Location Codes - F5/Rightmouse to Select or ESC to exit' ;
          TIMEOUT 60 FREEZE code

	    IF LASTKEY() = 23						&& Control-W
	  	  Cell = location->code
		  laArr[arr_row,4]=location->code
		  =Arr_disp[4]
		  IF RDLEVEL()=0
			 KEYBOARD CHR(13)+CHR(13)
		  ELSE
			 CLEAR READ
		  ENDIF
	    ENDIF
	ENDCASE
	ON KEY LABEL F3 DO pop_lst
	ON KEY LABEL F5
	RETURN
**
* STANDBY  -  User Prompt message.
**  
PROCEDURE standby
  PARAMETERS msgwords
  msgwords=LEFT(ALLTRIM(msgwords),70)
  ACTIVATE WINDOW standby
  @ 00,INT((72-LEN(msgwords))/2) SAY msgwords
  ?? CHR(7)
  @ 01,01
  WAIT SPACE(13)+'< Press a key or click the mouse to continue. > '
  DEACTIVATE WINDOW standby
  RETURN

**
* PMT_MSG  -   Function to display Prompt Messages
**
    FUNCTION pmt_msg
      PARAMETERS messg,override

	STORE 0 TO rowno      					&& Fix for cursor pos problem

	  IF PARAMETERS() >1
		IF override = 'T'
		  rowno=0
		ELSE
		  rowno=18
		ENDIF
	  ELSE
		rowno=ROW()
	  ENDIF

	  tmp2 = WONTOP()						&& Window on top
	  tmp1 = WLROW(WOUTPUT())				&& Position of active window
      tmp = WLROW('pmmsg')					&& Establish Prompt Window posn	  
	  IF ROWNO+tmp1 > 9
		IF tmp > 8
		  MOVE WINDOW pmmsg TO 2,6
		ENDIF
	  ELSE
	    IF tmp < 10
	  	  MOVE WINDOW pmmsg TO 18,6
	  	ENDIF
	  ENDIF
      ACTIVATE WINDOW pmmsg 
	  CLEAR
      @ 00,01 SAY "PROMPT: " + messg
      RETURN .t.

**
* PMT_CLR  -  Clear prompt window
**
    FUNCTION pmt_clr
      DEACTIVATE WINDOW pmmsg
      RETURN .t.
  
